HTML_folder = "800_480"
CREDITS_folder = "800_480"
headerLinePad = 8
gMoreMenuMargin = 40
gMoreMenuStep = 4
gMoreMenuScreenWith = 720
gMoreMenuWidth = gMoreMenuScreenWith / gMoreMenuStep
gMapMessageBoxY = 60
gMapMessageBoxYwithStart = 81
gJunctionViewDirectory = "800_480_Lanes"
ETmcMapSize = {x = 110, y = 135, w = 580, h = 280}
trMM_map = "0:x=47;y=62;w=339;h=218|100:x=0;y=0;w=800;h=480|"
SpeedlimitW = 100
SpeedlimitH = 102
USASpeedlimitW = 75
USASpeedlimitH = 79
SpeedcamW = 116
SpeedcamH = 70
SpeedcamSpeedlimitW = 103
SpeedcamSpeedlimitH = 105
rowHeight = 37
rowShift = 40
picShift = 10
lineNumbers = 26
pictoSize = 35
tableHeight = 80
maxRowHeight = 264
frameH = 4
DAiconIdx = 2
TMCIconIndex = 2
msgboxFlagIconIndex = 1
SatAnimRadius = 56
 
sc_SpeedCam_SetMapCenter = function()
  local mapLayer = MODEL.map.primary
  mapLayer.center_posx = 40
  mapLayer.center_posy = 63
end
 
sc_mainmenu_set_smallmap = function()
  primary.X = 57
  primary.Y = 56
  primary.Z = 40
  primary.W = 680
  MODEL.map.primary.show_labels_3d = false
  MODEL.map.primary.show_labels_2d = false
  primary:SCALE(float.new("0.48"))
end
 
sc_set_smallmap_WhereAmI = function()
  primary.X = 42
  primary.Y = 150
  primary.Z = 35
  primary.W = 716
  primary.H = 172
end
 
sc_set_smallmap_ColorScheme = function()
  primary.X = 36
  primary.Y = 95
  primary.Z = 35
  primary.W = 728
  primary.H = 268
end
 
sc_routemenu_info_fit_open_from_main = function(topLeft, bottomRight)
  MODEL.map.primary.mode = "2d"
  MODEL.map.primary.fit.x = 133
  MODEL.map.primary.fit.y = 141
  if (not MODEL.lua.mainMenuMode() or not 520) and (vActiveState() ~= "st_easyroutemethod" or not 326) then
  end
  MODEL.map.primary.fit.w = 383
  if MODEL.lua.showGreenUI() and not MODEL.lua.mainMenuMode() and MODEL.route.route_type() ~= L"GREEN" and MODEL.lua.GreenIsBetter() then
  MODEL.map.primary.fit.h = 185
  else
    MODEL.map.primary.fit.h = 229
  end
  sc_fit_to_screen_delay(topLeft, bottomRight)
  if st_HistoricalView.isActive and not MODEL.lua.map.ZoomOutEnabled() then
    MODEL.map.primary.zoom = MODEL.map.primary.maxzoom2d()
    MODEL.map.primary.center = MODEL.navigation.car.position()
  end
  MODEL.lua.TempMapCenter = MODEL.map.primary.center()
  MODEL.lua.TempMapZoom = MODEL.map.primary.zoom()
end
 
sc_fit_to_screen_delay = function(topLeft, bottomRight)
  if topLeft == nil or bottomRight == nil then
    topLeft, bottomRight = MODEL.route.get_boundrect()
  end
  local globe = MODEL.map.primary.fit.globe_enabled()
  MODEL.map.primary.fit.show(topLeft, bottomRight)
  MODEL.map.primary.fit.globe_enabled = true
  MODEL.map.primary.fit.show(topLeft, bottomRight)
  MODEL.map.primary.fit.globe_enabled = globe
end
 
sc_fit_resultpoi = function()
  local topLeft, bottomRight = MODEL.poi.resultpoi.get_boundingbox()
  sc_fit_general(topLeft, bottomRight, 133, 159, 533, 265)
  MODEL.lua.poiShowAllFlag = false
  MODEL.map.primary.show_cursor = false
  sc_SetPOICursorIcon()
  MODEL.lua.TempMapCenter = MODEL.map.primary.center()
  MODEL.lua.TempMapZoom = MODEL.map.primary.zoom()
end
 
sc_fit_avoid = function(topLeft, bottomRight)
  sc_fit_general(topLeft, bottomRight, 133, 141, 533, 282)
end
 
sc_fit_traffic_detour = function(topLeft, bottomRight)
  sc_fit_general(topLeft, bottomRight, 100, 106, 683, 300)
end
 
sc_fit_parking = function(topLeft, bottomRight)
  sc_fit_general(topLeft, bottomRight, 133, 168, 508, 238)
end

sc_GetMoreMenuAnim = function(X, Y)
  return "0:x=" .. X .. ";y=" .. Y .. ";w=175;h=173|100:x=0;y=0;w=800;h=480|"
end
 
sc_SetSignalH = function(signal)
  local h = 153 * (float.new(signal) / 50)
  return h:toInt()
end
 
sc_SetSignalY = function(signal)
  local h = 153 * (float.new(signal) / 50)
  return 316 - h:toInt()
end
 
sc_SetSignalPos = function(listsize, width, cellw)
  local pos = 0
  pos = width / 2 - listsize * cellw / 2
  return pos
end
 
sc_PosRecalcLayer = function()
  local State = vActiveState()
  if State == "st_easyroutemenu" or State == "st_currenttraffic" then
    ui_RecalcMsgBox.X = 205
    ui_RecalcMsgBox.Y = 5
  elseif State == "st_myroutemenu" then
    ui_RecalcMsgBox.X = 36
    ui_RecalcMsgBox.Y = 107
  elseif State == "st_avoiditinerentry" then
    ui_RecalcMsgBox.X = 173
    ui_RecalcMsgBox.Y = 194
  elseif State == "st_routeitiner" or State == "st_routeparamswithwarnings_route" then
    ui_RecalcMsgBox.X = 173
    ui_RecalcMsgBox.Y = 194
  elseif State == "st_avoidancesmenu" then
    ui_RecalcMsgBox.X = 217
    ui_RecalcMsgBox.Y = 212
  elseif State == "st_historicalview" then
    ui_RecalcMsgBox.X = 205
    ui_RecalcMsgBox.Y = 94
  end
end
 
sc_SelectMapCursor = function()
  local CursorIcon = MODEL.map.primary.cursor_icon()
  if CursorIcon == "cursor_places" then
    return "ico_cursorhead_place.bmp"
  elseif CursorIcon == "cursor_poi" or CursorIcon == "cursor_poi_brand" then
    return ""
  elseif CursorIcon == "cursor_tmc" then
    return "ico_cursorhead_tmc.bmp"
  else
    return "ico_cursorhead_cursor.bmp"
  end
end
 
sc_fit_blockedroad = function()
  local topLeft, bottomRight = MODEL.mydata.blocked_roads.get_boundrect()
  sc_fit_general(topLeft, bottomRight, 120, 35, 660, 353)
  MODEL.lua.TempMapCenter = MODEL.map.primary.center()
  MODEL.lua.TempMapZoom = MODEL.map.primary.zoom()
end
 
sc_fit_tracklog = function(topLeft, bottomRight, trackmode)
  if trackmode == 1 then
    MODEL.map.primary.center_posy = 65
    sc_fit_general(topLeft, bottomRight, 100, 146, 683, 344)
  else
    sc_fit_general(topLeft, bottomRight, 100, 106, 683, 304)
  end
end
 
sc_fit_itinerboxsize = function()
  local fit = MODEL.map.primary.fit
    fit.x = 133
    fit.y = 140
    fit.w = 534
    fit.h = 240
end
 
sc_OpenTrafficMapDetails = function()
  MODEL.lua.TrafficMapDetailsOpen = true
  ui_TrafficMapDetails:YBLEND(0, 85, 15)
  ui_EasyTMCMapControls:XBLEND(0, -117, 15)
  ui_rightcontrols_sublayer:YBLEND(120, 205, 15)
end
 
sc_CloseTrafficMapDetails = function()
  MODEL.lua.TrafficMapDetailsOpen = false
  ui_TrafficMapDetails:YBLEND(85, 0, 15)
  ui_EasyTMCMapControls:XBLEND(-117, 0, 15)
  ui_rightcontrols_sublayer:YBLEND(205, 120, 15)
end
 
sc_InstantCloseTrafficMapDetails = function()
  MODEL.lua.TrafficMapDetailsOpen = false
  ui_TrafficMapDetails:YBLEND(85, 0, 0)
  ui_EasyTMCMapControls:XBLEND(-117, 0, 0)
  ui_rightcontrols_sublayer:YBLEND(205, 120, 0)
end
 
sc_SetPictureSize = function()
  if MODEL.lua.pictloadhq() then
    spr_Pict:PICTW(2048)
    spr_Pict:PICTH(2048)
  else
    spr_Pict:PICTW(600)
    spr_Pict:PICTH(335)
  end
end
 
sc_SetFullScreenPictureSize = function()
  if MODEL.lua.pictloadhq() then
    spr_PictSlideShow:PICTW(2048)
    spr_PictSlideShow:PICTH(2048)
  else
    spr_PictSlideShow:PICTW(800)
    spr_PictSlideShow:PICTH(480)
  end
end
 
sc_SetSlideShowDemo = function()
  ui_PictSettings_SlideShowDemo.PictureW = 320
  ui_PictSettings_SlideShowDemo.PictureH = 371
end
 
sc_set_AdvMenuLayerPos = function()
  MODEL.lua.layerpos = 37
end
 
sc_GetLocalMenuBgY = function(size)
  local resultY = 282
  if size == 1 then
    resultY = 282
  elseif size == 2 then
    resultY = 174
  elseif size == 3 then
    resultY = 67
  end
  return resultY
end
 
sc_GetDemoTextH = function()
  ui_Demo_XHTML.W = 770
  ForceRefreshLayer(ui_Demo_XHTML)
  if MODEL.ui.ui_Demo_XHTML.can_scroll_up() or MODEL.ui.ui_Demo_XHTML.can_scroll_down() then
    ui_Demo_XHTML.W= 700
    ForceRefreshLayer(ui_Demo_XHTML)
  end
end
 
sc_ViaPositionSim = function(index)
  if MODEL.navigation.distance_total() > 0 then
    return (MODEL.navigation.distance_to_destination() - MODEL.route.list.navigated.waypoints.list[index].total_length()) * 454 / MODEL.navigation.distance_total()
  end
  return -100
end
 
sc_ViaPosition = function(index)
  if index > 0 and index < #MODEL.route.list.navigated.waypoints.list - 1 then
    return (MODEL.route.list.navigated.waypoints.list[MODEL.route.list.navigated.waypoints.list.lastindex()].total_length() - MODEL.route.list.navigated.waypoints.list[index].total_length()) * 257 / (MODEL.navigation.distance_to_destination() + MODEL.other.trips[0].distance_total())
  end
  return -100
end
 
sc_FitComparedRoutes = function(topLeft, bottomRight)
  if not topLeft:IsValid() or not bottomRight:IsValid() then
    return 
  end
  MODEL.map.primary.mode = "2d"
  MODEL.map.primary.fit.x = 133
  MODEL.map.primary.fit.y = 141
  MODEL.map.primary.fit.w = 383
  MODEL.map.primary.fit.h = 229
  local globe = MODEL.map.primary.fit.globe_enabled()
  MODEL.map.primary.fit.globe_enabled = true
  MODEL.map.primary.fit.show(topLeft, bottomRight)
  MODEL.map.primary.fit.globe_enabled = globe
  MODEL.lua.TempMapCenter = MODEL.map.primary.center()
  MODEL.lua.TempMapZoom = MODEL.map.primary.zoom()
end
 
sc_SetCountrySpecTMCIcon = function()
  local ID = MODEL.traffic.events.regionalize_icon(1000, MODEL.gps.position())
  gCountySpecTMCIcon = MODEL.screen.get_icon_file_and_phase(ID, 0)
  gCountySpecTMCIcon_Disabled = MODEL.screen.get_icon_file_and_phase(ID, 1)
end
 
sc_SetCockpitMap = function()
  if MODEL.lua.CockpitType() == 2 then
    primary.X = 157
    primary.Y = 0
    primary.Z = 0
    primary.W = mapResW - 162
    primary.H = mapResH
  else
    primary.X = 0
    primary.Y = 0
    primary.Z = 0
    primary.W = mapResW
    primary.H = mapResH
  end
end

sc_getMoreMenuBtnBmp = function(i)
  local index = i + 1
  local size = MODEL["*"]._list.size()
  if index == 1 then
    return "button_topleft.bmp#3"
  elseif index == size then
    return "button_bottomright.bmp#3"
  else
    return "button.bmp#3"
  end
end
 
sc_getPicViewerBtnBmp = function(i)
  local index = i + 1
  local residuum = index % 8
  if residuum == 1 then
    return "button_topleft.bmp#3"
  elseif residuum == 0 then
    return "button_bottomright.bmp#3"
  else
    return "button.bmp#3"
  end
end
 
sc_getSlapiDMenuBtnBmp = function(i, isLeft, isCheckbox)
  local index = i + 1
  local size = MODEL["*"]._list.size()
  if index == 1 and isLeft then
    if isCheckbox then
      return "button_topleft_nopress.bmp#3"
    else
      return "button_topleft.bmp#3"
    end
  elseif index == size and not isLeft then
    if isCheckbox then
      return "button_bottomright_nopress.bmp#3"
    else
      return "button_bottomright.bmp#3"
    end
  elseif isCheckbox then
    return "button_nopress.bmp#3"
  else
    return "button.bmp#3"
  end
end
 
sc_SetVRBackground = function(status)
  if MODEL.EXISTS.vr() then
    if MODEL.lua.VRError() then
      return "vr_error_bg.bmp"
    end
    if status == eVRStatus.listen then
      if MODEL.vr.engine_state() == 1 then
        return "vr_talk_bg.bmp"
      else
        return "vr_listen_bg.bmp"
      end
    elseif status == eVRStatus.click then
      return "vr_click_bg.bmp"
    else
      return "vr_click_bg.bmp"
    end
  end
  return "vr_click_bg.bmp"
end
 
sc_SetVRMessageboxBackground = function(status)
  if MODEL.EXISTS.vr() then
    if MODEL.lua.VRError() then
      return "msgbox_vr_error_bg_skincol.bmp"
    end
    if status == eVRStatus.listen then
      if MODEL.vr.engine_state() == 1 then
        return "msgbox_vr_talk_bg_skincol.bmp"
      else
        return "msgbox_vr_listen_bg_skincol.bmp"
      end
    elseif status == eVRStatus.click then
      return "msgbox_bg_skincol.bmp"
    else
      return "msgbox_bg_skincol.bmp"
    end
  end
  return "msgbox_bg_skincol.bmp"
end
 
sc_SetVRMapMessageboxBackground = function(status)
  local backgroundBmp = "map_msgboxbluehigh_spr_skincol.bmp"
  if MODEL.EXISTS.vr() then
    if MODEL.vr.ui.phase_running() then
      if MODEL.vr.engine_state() == 1 then
        backgroundBmp = "map_msgbox_vr_talk_spr_skincol.bmp"
      else
        backgroundBmp = "map_msgbox_vr_listen_spr_skincol.bmp"
      end
    elseif MODEL.lua.VRError() then
      backgroundBmp = "map_msgbox_vr_error_spr_skincol.bmp"
    end
  end
  return backgroundBmp
end
 
sc_getKeyLeft12 = function(keyindex)
  return 63 * keyindex
end
 